// Bar effect

{
	// Palkki-efekti
	efPalkki = new Object();
	
	efPalkki.init = function () {
		var skiin = document.getElementById('efektiBar');
		palkki.prototype.efekti = this;
		
		// Malli palkiksi
		this.eProtoBar = skiin.removeChild(document.getElementById('bar'));
		
		this.scene = eScene.removeChild(skiin);
		
		this.activateBars = { 10: new palkki(0,'#ff0000'),
			                  50: new palkki(2.5,'#00ff00'),
					          70: new palkki(1,'#0000ff')
		}
	}
	
	efPalkki.begin = function () {
		eScene.appendChild(this.scene);
		//eScene.insertBefore(this.scene, document.getElementById('tahtiboksi'));
		
		//palkit = [new palkki(0,'white'),new palkki(Math.PI*2/5,'red'), new palkki(Math.PI*4/5,'green'), new palkki(Math.PI*6/5,'blue'), new palkki(Math.PI*8/5,'yellow')];
		this.palkit = [];
		this.beginFrame = iFrame;
	}
	
	efPalkki.end = function () {
		// Siivoa ruutu
		eScene.removeChild(this.scene);
	}
	
	function palkki(kulma,vari) {
		this.eBar = this.efekti.eProtoBar.cloneNode(false);
		this.aBarY = this.eBar.getAttributeNode('y');
		
		//this.efekti.scene.insertBefore(this.eBar,this.efekti.eLast);
		this.efekti.scene.appendChild(this.eBar);
		this.angle = kulma;
		
		this.eBar.setAttribute('fill',vari);
		this.opacity = 0;
		
	}
	
	palkki.prototype.amplitude = 200;
	palkki.prototype.increment = 0.2;
	palkki.prototype.opacityInc = 0.01;
	
	palkki.prototype.recalc = function() {
		const iBarYmid = 410;
		
		this.angle += this.increment;
		if (this.angle > pi2) {
			this.angle -= pi2;
		}
		
		this.aBarY.value = Math.sin(this.angle)*this.amplitude+iBarYmid;
		this.cosine = Math.cos(this.angle);
		
		if (this.opacity < 1) {
			this.opacity += this.opacityInc;
			if (this.opacity > 1) this.opacity = 1;
			this.eBar.setAttribute('style','opacity:'+this.opacity);
		}
	}
	
	function sortZindex( palkki1, palkki2 ) {
		return palkki1.cosine - palkki2.cosine;
	}
	
	efPalkki.draw = function() {
		var newBar = this.activateBars[(iFrame-this.beginFrame)];
		if (newBar) {
			this.palkit.push(newBar);
		}
		
		for ( i in this.palkit ) {
			this.palkit[i].recalc();
		}
		
		this.palkit.sort(sortZindex);
		for ( i in this.palkit ) {
			//this.scene.insertBefore(this.palkit[i].eBar,this.eLast);
			this.scene.appendChild(this.palkit[i].eBar);
		}
	}
}